/*    
**  ShellyLibV2.2 - the ShellShapeGenerator 
**
**  Copyright (C) 1997 Randolf Schultz (rschultz@informatik.uni-rostock.de)
**
**  This software is shareware!
**  Read the file "License" for further information.
*/

/* Surface Shader 						*/
/* maps a texture generated by the                              */
/* Shell Laboratory onto the shell shape	                */
/* Parameters: 							*/
/* texturename: guess                                           */
/* mys: texture coordinates for s-direction                     */

surface
SLtxtsrf( 
        float   Ka = 1, Kd = 1, Ks = 0.8, roughness = 0.1;
	color   speccol = 1;
	string  texturename;
	varying float mys = 0;
)
{
        point   Nf;
	color   col = 1;

	col = color texture(texturename,t,mys,"swidth",0.1,"twidth",0.1);

        Nf = faceforward(normalize(N), I);

        Oi = Os;
        Ci = Os * col * ((Ka * ambient() + Kd * diffuse(Nf)) + 
	     speccol * Ks * specular(Nf, normalize(I), roughness));
}

